#version 330
                                  
layout(points) in;                                                                  
layout(triangle_strip) out;                                                         
layout(max_vertices = 4) out;    
in vec3 fragColorOut[];                                                   
                                                                                     
uniform mat4 VP;                                                                   
uniform vec3 cameraPos;                                                            
uniform float gBillboardSize;                                                      
                                                                                    
out vec2 TexCoord; 
out vec4 position;   
out vec3 normal;                                                              
out vec3 fragColorOutOut;
                                                                          
void main()                                                                         
{                                                                                
    vec3 Pos = gl_in[0].gl_Position.xyz;                                            
    vec3 toCamera = normalize(cameraPos - Pos);                                    
    vec3 up = vec3(0.0, 1.0, 0.0);                                                  
    vec3 right = cross(toCamera, up) * gBillboardSize;                              
                                                                                    
    Pos -= right;                                                                   
    gl_Position = VP * vec4(Pos, 1.0);                                             
    TexCoord = vec2(0.0, 0.0);   
    position =  gl_Position;   
    normal  = toCamera;  
    fragColorOutOut = fragColorOut[0];                                              
    EmitVertex();                                                                   
                                                                                    
    Pos.y += gBillboardSize;                                                        
    gl_Position = VP * vec4(Pos, 1.0);                                             
    TexCoord = vec2(0.0, 1.0);     
    position =  gl_Position; 
    normal = toCamera;     
    fragColorOutOut = fragColorOut[0];                                                     
    EmitVertex();                                                                   
                                                                                    
    Pos.y -= gBillboardSize;                                                        
    Pos += right;                                                                   
    gl_Position = VP * vec4(Pos, 1.0);                                             
    TexCoord = vec2(1.0, 0.0);  
    position =  gl_Position;   
    normal = toCamera;    
    fragColorOutOut = fragColorOut[0];                                                       
    EmitVertex();                                                                   
                                                                                    
    Pos.y += gBillboardSize;                                                        
    gl_Position = VP * vec4(Pos, 1.0);                                             
    TexCoord = vec2(1.0, 1.0); 
    position =  gl_Position;  
    normal = toCamera;   
    fragColorOutOut = fragColorOut[0];                                                          
    EmitVertex();                                                                   
                                                                                    
    EndPrimitive();                                                                 
}                    