#version 330

//Shader that simply passes a particle to the geometry shader

in float Type;
in vec3 Position;
in vec3 Velocity;
in float Age;
in vec3 Color;
in float Lifetime;

out float Type0;
out vec3 Position0;
out vec3 Velocity0;
out float Age0;
out vec3 Color0;
out float Lifetime0;

#define PARTICLE_TYPE_LAUNCHER 0.0f                                                  
#define PARTICLE_TYPE_NORMAL 1.0f   

const float TwoPi = 6.28318530718;
const float InverseMaxInt = 1.0 / 4294967295.0;

float randhash(uint seed, float b)
{
    uint i=(seed^12345391u)*2654435769u;
    i^=(i<<6u)^(i>>26u);
    i*=2654435769u;
    i+=(i<<5u)^(i>>12u);
    return float(b * i) * InverseMaxInt;
}    

void main()
{

    Type0 = Type;
    Position0 = Position;
    Velocity0 = Velocity;
    if(Type == PARTICLE_TYPE_NORMAL){
		uint seed = uint(Age0 * 1000.0) + uint(gl_VertexID);
        float theta = randhash(seed++, TwoPi);
        float x = cos(theta);
        float z = sin(theta);
        float r  = 0.5;
        if(Position.y > 1.5){
            r = -0.3;
        }
    	vec3 VelocityRND = vec3(r*x, 0.1, r*z);
		Velocity0 = VelocityRND;
    }
    Age0 = Age;
	Color0 = Color; 
	Lifetime0 = Lifetime; 
} 