#version 330                                                                         
                                                                                     
layout(points) in;                                                                   
layout(points) out;                                                                  
layout(max_vertices = 30) out;                                                       
                                                                                     
in float Type0[];                                                                    
in vec3 Position0[];                                                                 
in vec3 Velocity0[];                                                                 
in float Age0[]; 
in vec3 Color0[];                                                                     
in float Lifetime0[];            
		                                                                             
out float Type1;                                                                     
out vec3 Position1;                                                                  
out vec3 Velocity1;                                                                  
out float Age1;     
out vec3 Color1;    
out float Lifetime1;                                                               
                                                                                     
uniform float deltaT;
uniform float maxHeight;
                                       
#define PARTICLE_TYPE_LAUNCHER 0.0f                                                  
#define PARTICLE_TYPE_NORMAL 1.0f       
                                                

void main(){                             
                                                                                     
    if (Type0[0] == PARTICLE_TYPE_LAUNCHER) { 
		                        
        Type1 = PARTICLE_TYPE_LAUNCHER;    
		Color1 = Color0[0];
		Lifetime1 = Lifetime0[0];                        
		Velocity1 = Velocity0[0];                                             
		Position1 = Position0[0];            
		Age1 = Age0[0] + deltaT;                                                        
		EmitVertex();                                                            
		EndPrimitive(); 

		Type1 = PARTICLE_TYPE_NORMAL;
		Color1 = vec3(1.0, 1.0, 0.6);
		Lifetime1 = Lifetime0[0];                        
		Velocity1 = Velocity0[0];  
		Position1 = Position0[0] + vec3(1.0,0,0)*deltaT;  
		Age1 = 0.0;             
		EmitVertex();                                                            
		EndPrimitive(); 

		
		Type1 = PARTICLE_TYPE_NORMAL;
		Color1 = vec3(1.0, 1.0, 0.8);
		Lifetime1 = Lifetime0[0];                        
		Velocity1 = Velocity0[0];  
		Position1 = Position0[0] + vec3(-1.0,0,0)*deltaT;  
		Age1 = 0.0;           
		EmitVertex();                                                            
		EndPrimitive();
		
		Type1 = PARTICLE_TYPE_NORMAL;
		Color1 = vec3(1.0, 1.0, 0.8);
		Lifetime1 = Lifetime0[0];                        
		Velocity1 = Velocity0[0];  
		Position1 = Position0[0] + vec3(0,0,1)*deltaT;  
		Age1 = 0.0;           
		EmitVertex();                                                            
		EndPrimitive();

		Type1 = PARTICLE_TYPE_NORMAL;
		Color1 = vec3(1.0, 1.0, 0.8);
		Lifetime1 = Lifetime0[0];                        
		Velocity1 = Velocity0[0];  
		Position1 = Position0[0] + vec3(0,0,-1)*deltaT;  
		Age1 = 0.0;           
		EmitVertex();                                                            
		EndPrimitive();
		                                                                                                                                                                               
    } 

    //if its  a  fire particle and under a  certain height, update it - else nothing
    else{

    	if(Position0[0].y < 2.3 )  {  //2.3 is gut	//height  total = maxposition -  startposition , =  2.3  - 1.7 = 0.6

    	Type1 = PARTICLE_TYPE_NORMAL;

    	float deltaHeight = ((Position0[0].y-1.7)/0.6); 
    	//Color1 = vec3(1-deltaHeight, 1-deltaHeight, 1-deltaHeight); 
    	Color1 = Color0[0] - vec3(0.0, 0.01*(1-deltaHeight), 0.04);
		Lifetime1 = Lifetime0[0];                        
		Velocity1 = Velocity0[0];  
    	Position1 = Position0[0] + Velocity0[0]*deltaT;    
    	Age1 = Age0[0] + deltaT; 

		EmitVertex();                                                            
		EndPrimitive(); 
		}

    }
 
}                                    
