#version 330 core

uniform sampler2D colorTexture;
uniform float far;
uniform float near;

uniform int debug;

uniform vec3 overrideColor;

in vec3 fragPosition;
in vec2 fragTexCoords;
in vec3 fragNormal;

layout (location = 0) out vec4 gPosition;
layout (location = 1) out vec3 gNormal;
layout (location = 2) out vec3 gAlbedo;

//via http://learnopengl.com/#!Advanced-Lighting/SSAO
float linearizeDepth(float depth){
	float z = depth * 2.0 - 1.0;
	return (2.0 * far * near) / (far + near - z * (far - near));
}

void main()
{
	gPosition.xyz = fragPosition;
	gPosition.a = linearizeDepth(gl_FragCoord.z);
	gNormal = normalize(fragNormal);
	if(overrideColor.r != -1){
		gAlbedo = overrideColor;
	} else {
		gAlbedo = texture(colorTexture, fragTexCoords).rgb;
	}

	if(debug == 1) gAlbedo = vec3(0.95);
}