#version 330 core

layout (location = 0) in vec3 position;
layout (location = 1) in vec2 uv;
layout (location = 2) in vec3 normal;

out vec3 fragPosition;
out vec2 fragTexCoords;
out vec3 fragNormal;

uniform mat4 projectionMatrix;
uniform mat4 modelViewMatrix;

void main() 
{
	fragTexCoords = uv;
	fragNormal = (modelViewMatrix * vec4(normal, 0)).xyz; //
	fragPosition = (modelViewMatrix * vec4(position, 1)).xyz;
	gl_Position = projectionMatrix * modelViewMatrix * vec4(position, 1);
}