#version 410 core

// adapted from http://ogldev.atspace.co.uk/www/tutorial30/tutorial30.html
// http://prideout.net/blog/?p=48
// http://in2gpu.com/2014/07/12/tessellation-tutorial-opengl-4-3/

in vec2 TexCoord_FS_in;
in vec3 Normal_FS_in;
in vec3 WorldPos_FS_in;

layout (location = 0) out vec4 gPosition;
layout (location = 1) out vec3 gNormal;
layout (location = 2) out vec3 gAlbedo;

uniform sampler2D colorTexture;
uniform float far;
uniform float near;

uniform int debug;

//via http://learnopengl.com/#!Advanced-Lighting/SSAO
float linearizeDepth(float depth){
	float z = depth * 2.0 - 1.0;
	return (2.0 * far * near) / (far + near - z * (far - near));
}

void main()
{
	gPosition.xyz = (vec4(WorldPos_FS_in, 1.0)).xyz;
	gPosition.a = linearizeDepth(gl_FragCoord.z);
	gNormal = normalize(vec4(Normal_FS_in, 1.0)).xyz;
	
	if(debug == 1) {
		gAlbedo = vec3(0.95);
	} else {
		gAlbedo = texture(colorTexture, TexCoord_FS_in.xy).rgb;
	}
}