#version 400 core

layout (triangles) in;
layout (triangle_strip, max_vertices=18) out;

//in vec3 FragPosWorld;

//the P*V[i] matrices, transform from world to CM-face #i
uniform mat4 shadowMatrices[6];

out vec4 FragPosWorld; // FragPos from GS (output per emitvertex)

void main()
{
    //for each face
    for(int face = 0; face < 6; ++face)
    {
	gl_Layer = face; 

	
        for(int i = 0; i < 3; ++i) // for each triangle
        {
            FragPosWorld = gl_in[i].gl_Position;
            gl_Position = shadowMatrices[face] * FragPosWorld;
            EmitVertex();
        }    

        EndPrimitive();
    }
}  